/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.android.spatialindex.poi;

import es.prodevelop.android.spatialindex.poi.POI;
import es.prodevelop.gvsig.mini.common.impl.CollectionQuickSort;

public class POIAlphabeticalQuickSort extends CollectionQuickSort {

	public boolean less(Object x, Object y) {
		String xx = ((POI) x).getDescription().toLowerCase();
		String yy = ((POI) y).getDescription().toLowerCase();

		char ix = xx.charAt(0);
		char iy = yy.charAt(0);

		int length = Math.min(xx.length(), yy.length());

		for (int i = 1; i < length; i++) {
			if (ix == iy) {
				ix = xx.charAt(i);
				iy = yy.charAt(i);
			} else {
				return (ix < iy);
			}
		}
		return (ix < iy);
	}
}
