/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.android.spatialindex.quadtree;

public class QuadtreeBox {

	public double Left;
	public double Right;
	public double Front;
	public double Back;

	public QuadtreeBox(double xMax, double xMin, double yMax, double yMin) {
		Right = xMax;
		Left = xMin;
		Front = yMax;
		Back = yMin;
	}

	public boolean within(QuadtreeBox Box) {
		return within(Box.Left, Box.Right, Box.Front, Box.Back);
	}

	public boolean within(double xMax, double xMin, double yMax, double yMin) {
		if (xMin >= Right || xMax < Left || yMin >= Front || yMax < Back)
			return false;

		return true;
	}

	public boolean pointWithinBounds(double x, double y) {
		if (x <= Right && x > Left && y <= Front && y > Back)
			return true;
		else
			return false;
	}

	public double borderDistance(double x, double y) {

		double ewdistance;
		double fbdistance;

		if (Left <= x && x <= Right)
			ewdistance = 0;
		else
			ewdistance = Math.min((Math.abs(x - Right)), (Math.abs(x - Left)));

		if (Front <= y && y <= Back)
			fbdistance = 0;
		else
			fbdistance = Math.min(Math.abs(y - Back), Math.abs(y - Front));

		return Math.sqrt(ewdistance * ewdistance + fbdistance * fbdistance);
	}
}
