package es.prodevelop.android.spatialindex.quadtree.bucket.mr;

import es.prodevelop.android.spatialindex.quadtree.bucket.BucketPRQuadtreeNode;
import es.prodevelop.gvsig.mini.geom.Point;

public class LastPointMedoidCandidateSelector extends
		ClosestToQuadrantMedoidCandidateSelector {

	private int numPoints = 0;
	private Point medoid = new Point(0, 0);
	private Point temp = new Point(0, 0);

	public boolean isCandidate(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		if (candidateX == 0 || candidateY == 0) return false;
		numPoints++;
		temp.setX(temp.getX() + candidateX);
		temp.setY(temp.getY() + candidateY);
		
		medoid.setX(temp.getX() / numPoints);
		medoid.setY(temp.getY() / numPoints);
		
		return true;
	}

	public double[] getMedoidXY(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		return new double[] { medoid.getX(), medoid.getY() };
	}
	
	public MedoidCandidateSelector getSelector() {
		return new LastPointMedoidCandidateSelector();
	}
}