package es.prodevelop.android.spatialindex.quadtree.bucket.mr;

import java.util.ArrayList;
import java.util.Vector;

import es.prodevelop.android.spatialindex.quadtree.QuadtreeLeaf;
import es.prodevelop.android.spatialindex.quadtree.bucket.BucketPRQuadtreeNode;
import es.prodevelop.gvsig.mini.geom.Point;

public class MassCenterCandidateSelector implements MedoidCandidateSelector {

	private Point massCenter = new Point(0, 0);
	// private double distance;
	private double numItems = 0.0;
	private Point nearest = new Point(Double.MAX_VALUE, Double.MAX_VALUE);
	private double minDistance = Double.MAX_VALUE;	

	public boolean isCandidate(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		if (candidateX == 0 || candidateY == 0)
			return false;
		// GeometryFactory factory = new GeometryFactory();
		//
		// ArrayList points = ((MRBucketPRQuadtreeNode) cluster).points;
		//
		// Geometry multiPoint = factory.createMultiPoint(GeometryFactory
		// .toPointArray(points));
		// com.vividsolutions.jts.geom.Point interiorPoint = multiPoint
		// .getInteriorPoint();
		// System.out.println("NUM_ITEMS: " + cluster.toString() + " " +
		// numItems);
		numItems++;
		massCenter.setX(massCenter.getX() + candidateX);
		massCenter.setY(massCenter.getY() + candidateY);		

		int maxSize = Integer.MIN_VALUE;
		if (cluster.hasChildren()) {
			MRBucketPRQuadtreeNode[] nodes = (MRBucketPRQuadtreeNode[])cluster.getBranch();
			if (nodes == null) {
				return false;
			}
			MRBucketPRQuadtreeNode node;
			for (int i = 0; i<nodes.length; i++) {
				node = nodes[i];
				if (node.getClusterNumItems() > maxSize && node.getClusterNumItems() > 0) {
					maxSize = node.getClusterNumItems();
					nearest.setX(node.getMedoidX());
					nearest.setY(node.getMedoidY());
				}
			}
			return true;

//			Point mC = new Point(massCenter.getX() / numItems,
//					massCenter.getY() / numItems);
//
//			double dist = mC.distance(candidateX, candidateY);
//			double currentDist = mC.distance(currentMedoidX, currentMedoidY);
//
//			if (dist < currentDist) {
//				if (dist < minDistance) {
//					minDistance = dist;
//					nearest = new Point(candidateX, candidateY);
//					return true;
//				}
//			} else {
//				if (currentDist < minDistance) {
//					minDistance = dist;
//					nearest = new Point(currentMedoidX, currentMedoidY);
//					return true;
//				}
//			}
		} else {			
			Vector points = cluster.items;
			final int size = points.size();

			Point p;
			Point mC = new Point(massCenter.getX() / numItems,
					massCenter.getY() / numItems);
			
//			Point mC = new Point(0, 0);
			

			double dist = Double.MAX_VALUE;
//			for (int i = 0; i < size; i++) {
//				p = (Point) ((QuadtreeLeaf)points.get(i)).getObjectValue();
//				mC.setX(mC.getX() + p.getX());
//				mC.setY(mC.getY() + p.getY());
//			}
//			
//			mC.setX(mC.getX() /size);
//			mC.setY(mC.getY() /size);
			minDistance = Double.MAX_VALUE;
			
			for (int i = 0; i < size; i++) {
				p = (Point) ((QuadtreeLeaf)points.get(i)).getObjectValue();
				dist = mC.distance(p);
				if (dist < minDistance) {
					minDistance = dist;
					nearest = p;
				}				
			}
			
			return true;
		}
//		return false;
	}

	public double[] getMedoidXY(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		return new double[] { nearest.getX(), nearest.getY() };
	}

	public int getCandidateID(Object candidate) {
		// TODO Auto-generated method stub
		return 0;
	}

	public MedoidCandidateSelector getSelector() {
		return new MassCenterCandidateSelector();
	}

}
