package es.prodevelop.android.spatialindex.quadtree.bucket.mr;

import java.util.ArrayList;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryFactory;

import es.prodevelop.android.spatialindex.quadtree.bucket.BucketPRQuadtreeNode;
import es.prodevelop.gvsig.mini.geom.Point;

public class Random2CandidateSelector extends
		ClosestToQuadrantMedoidCandidateSelector {

	private int numPoints = 0;
	private Point medoid = new Point(0, 0);
	private Point temp = null;
	private Coordinate[] prevCoords;
	private ArrayList points = new ArrayList();

	public boolean isCandidate(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		if (candidateX == 0 || candidateY == 0)
			return false;
		numPoints++;

		// Coordinate[] coords = new Coordinate[numPoints];
		// if (prevCoords != null)
		// System.arraycopy(prevCoords, 0, coords, 0, numPoints - 1);
		//
		// coords[numPoints - 1] = new Coordinate(candidateX, candidateY);
		GeometryFactory factory = new GeometryFactory();

		points = new ArrayList();
		if (temp != null)
			points.add(factory.createPoint(new Coordinate(temp.getX(), temp
					.getY())));

		points.add(factory.createPoint(new Coordinate(candidateX, candidateY)));
		Geometry multiPoint = factory.createMultiPoint(GeometryFactory
				.toPointArray(points));		
		com.vividsolutions.jts.geom.Point interiorPoint = multiPoint
				.getInteriorPoint();

		temp = new Point(interiorPoint.getCoordinate().x,
				interiorPoint.getCoordinate().y);

		// prevCoords = coords;
		if (interiorPoint.getCoordinate().x == candidateX
				&& interiorPoint.getCoordinate().y == candidateY) {
			medoid.setX(candidateX);
			medoid.setY(candidateY);
			return true;
		}

		return false;
	}

	public double[] getMedoidXY(double candidateX, double candidateY,
			double currentMedoidX, double currentMedoidY,
			BucketPRQuadtreeNode cluster) {
		return new double[] { medoid.getX(), medoid.getY() };
	}
	
	public MedoidCandidateSelector getSelector() {
		return new Random2CandidateSelector();
	}

}
