/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 *   
 */

package es.prodevelop.android.spatialindex.quadtree.memory;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Vector;

import es.prodevelop.gvsig.mini.geom.Extent;

/**
 * 
 * @author aromeu
 */
public class Tree {
	public TreeNode root;
	public Extent maxExtent;
	public ArrayList archives = new ArrayList();

	public Tree(TreeNode root, Extent bounds) {
		this.maxExtent = bounds;
		this.root = root;
	}

	public ArrayList getPOIs(Extent bounds) {
		archives = new ArrayList();
		this.getPOIs(root, maxExtent, bounds);
		return archives;
	}

	private void getPOIs(TreeNode rootNode, Extent rootBounds, Extent bounds) {

		if (rootNode == null || rootBounds == null || bounds == null) {
			return;
		}

		// System.out.println(rootBounds.toString());

		if (!rootBounds.intersect(bounds)) {
			return;
		}

		if (rootNode instanceof TreeLeaf) {
			getArchives().add(
					String.valueOf(((TreeLeaf) rootNode).getArchive()));
			return;
		}

		Extent[] extents = rootNode.getExtents(rootBounds);

		/** Recursivelly get pois **/
		if (extents[0] != null)
			if (extents[0].intersect(bounds)) {
				// System.out.println(extents[0].toString());
				this.getPOIs(rootNode.getUL(), extents[0], bounds);
			}

		if (extents[1] != null)
			if (extents[1].intersect(bounds)) {
				// System.out.println(extents[1].toString());
				this.getPOIs(rootNode.getUR(), extents[1], bounds);
			}

		if (extents[2] != null)
			if (extents[2].intersect(bounds)) {
				// System.out.println(extents[1].toString());
				this.getPOIs(rootNode.getBL(), extents[2], bounds);
			}

		if (extents[3] != null)
			if (extents[3].intersect(bounds)) {
				// System.out.println(extents[1].toString());
				this.getPOIs(rootNode.getBR(), extents[3], bounds);
			}
	}

	public ArrayList getArchives() {
		return archives;
	}

	public void setArchives(ArrayList archives) {
		this.archives = archives;
	}
}
