/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.android.spatialindex.quadtree.persist.perst;

import org.garret.perst.FieldIndex;
import org.garret.perst.Index;
import org.garret.perst.Storage;

import es.prodevelop.android.spatialindex.cluster.Cluster;

/**
 * A Persistent root to store clusters. It has a FieldIndex by ID of a Cluster
 * to retrieve them when needed. A simplified version of ClusterTree is stored
 * into an Index by String (@see POICategories). This allows to load in memory a
 * ClusterTree by category of OsmPOI
 * 
 * @see MRBucketPRQuadtree, ClusterNode, ClusterTree, Cluster
 * @author aromeu
 * 
 */
public class OSMPoiClusterSpatialIndexRoot extends OSMPoiSpatialIndexRoot {

	private FieldIndex idIndex;
	private Index clusterTreeIndex;	

	public OSMPoiClusterSpatialIndexRoot() {
		super();
		// TODO Auto-generated constructor stub
	}

	public OSMPoiClusterSpatialIndexRoot(Storage db) {
		super(db);
		// FIXME
		// The ID should be UNIQUE, find a valid unique ID to store Clusters
		idIndex = db.createFieldIndex(Cluster.class, "ID", false);
		clusterTreeIndex = db.createIndex(String.class, true);		
	}

	public FieldIndex getIDIndex() {
		return idIndex;
	}

	public Index getClusterTreeIndex() {
		return this.clusterTreeIndex;
	}
}
